#include "woorms.h"
#include "config.h"

int RX=CLI_RX_DEF;
int RY=CLI_RY_DEF;
int SPEED=CLI_SPEED_DEF;

int REFRMOD=5;
int BWTERM=0;

int sw[2+1];
int curs,gout,zm,zm2,zm3,fout;
volatile int siig;
int myn[2+1];
int rel[2+1];
int relk[2+1];
char *nme[2+1];

int conn_open(char *host,int port)
{
int s;
struct sockaddr_in sin;

s=socket(AF_INET,SOCK_STREAM,0);
sin.sin_family = AF_INET;
sin.sin_port = htons(port);
sin.sin_addr.s_addr = conn_resolve(host);
ie(connect(s,(struct sockaddr *) &sin,sizeof(sin)),"Cannot connect to server\n");
fcntl(s,F_SETFL,O_NONBLOCK);
return(s);
}

char *pckt;

int zd,zm;
char *stata, *statt, *statr, *stati, *statc, *stats, *wt;
char kp,kc,kr;
WINDOW *wm;
char *tks[2][12+1];

int tikk;

int PORT;
char *HOST;

void area_put(int ly,int lx,char c,int co)
{
area_putp(ly,lx,c,co);
};

void stat_put(char *ch)
{
stat_putp(ch);
}

struct sigaction siga;

void handlerf(int i)
{
if (i==SIGALRM)
{
tikk=(tikk+1)%(REFRMOD-1);
if (siig==0 && tikk==0)
{
siig=1;
stat_putp(NULL);
siig=0;
}
}
}

void key_press(char k,int nn)
{
char tsn;

if (rel[nn] && relk[nn]>0)
{
if (k==2 || k==4)
{
tsn=k-3;
tsn=(relk[nn]+3-tsn)%4+1;
rel[nn]=0;
key_press(tsn,nn);
rel[nn]=1;
}
}
else
{
tsn=k;
send(sw[nn],&tsn,1,0);
relk[nn]=k;
}
}

void txt_load(char *fn,int wn,int mxm)
{
char *fn3=malloc(256);

#if HAVE_ZLIB==1
gzFile fds;
#else
int fds;
#endif

zm=0;
*fn3=0;

if (fn!=NULL)
{

#if HAVE_ZLIB==1
file_select(fn3,fn,DATA_DIR "/" CLI_TEXTS_DIR "/",".gz");
file_select(fn3,fn,DATA_DIR "/" CLI_TEXTS_DIR "/","");
file_select(fn3,fn,"./",".gz");
file_select(fn3,fn,"./","");
ie((NULL!=(fds=gzopen(fn3,"rb")))-1,"Cannot open texts file\n");
while (gzread(fds,&kc,1)>0 && zm<=mxm)
#else
file_select(fn3,fn,DATA_DIR "/" CLI_TEXTS_DIR "/","");
file_select(fn3,fn,"./","");
ie(fds=open(fn3,O_RDONLY),"Cannot open texts file\n");
while (read(fds,&kc,1)>0 && zm<=mxm)
#endif
{
if (kc==10 || zm==0)
{
zm++;
zm2=0;
tks[wn][zm]=(char *) malloc(RX);
}
if (kc!=10 && zm2<(RX-1))
{
*(tks[wn][zm]+zm2)=kc;
*(tks[wn][zm]+zm2+1)=0;
zm2++;
}
}
#if HAVE_ZLIB==1
gzclose(fds);
#else
close(fds);
#endif
}
free(fn3);
}

int main (int argc, char *argv[])
{
nice(CLI_NICE);
pckt=(char *) malloc(4);
stata=(char *) malloc(RX*2);
statt=(char *) malloc(RX*2);
statr=(char *) malloc(RX);
stati=(char *) malloc(RX);
statc=(char *) malloc(RX*2);
stats=(char *) malloc(RX*2);
HOST=(char *) malloc(100);

strcpy(HOST,CLI_HOST_DEF);
PORT=CLI_PORT_DEF;
curs=0;
rel[1]=0;
rel[2]=0;
myn[1]=(-1);
myn[2]=(-1);
nme[1]=(char *) malloc(9);
nme[2]=(char *) malloc(9);
*(nme[1])=0;
*(nme[2])=0;
do {
zm=getopt(argc,argv,"p:h:m:x:y:rRn:N:s:f:F:M");
if (! (zm==EOF))
{
switch(zm)
{
case '?':
case ':':
{
sprintf(statr,"Usage: %s [-h host] [-p port] [-x xres] [-y yres] [-r] [-R] [-n name]",argv[0]);
sprintf(statr+strlength(statr)," [-N name] [-s speed] [-f txtfile] [-F txtfile] [-M]\n");
ie(-1,statr);
}
case 'p': PORT=atoi(optarg); break;
case 'h': strncpy(HOST,optarg,99); break;
case 'x': RX=atoi(optarg); break;
case 'y': RY=atoi(optarg); break;
case 'r': rel[1]=1; break;
case 'R': rel[2]=1; break;
case 'n': strncpy(nme[1],optarg,9); *(nme[1]+8)=0; break;
case 'N': strncpy(nme[2],optarg,9); *(nme[2]+8)=0; break;
case 's': SPEED=atoi(optarg); break;
case 'f': txt_load(optarg,0,12); break;
case 'F': txt_load(optarg,1,6); break;
case 'M': BWTERM=1;
}
}
} while (! (zm==EOF));

sw[1]=conn_open(HOST,PORT);
send(sw[1],nme[1],strlength(nme[1])+1,0);
myn[1]=0;
while (recv(sw[1],&zm2,1,0)<1);
if (zm2!=PROTOCOL)
{
sprintf(statr,"Server requests v%d protocol, and your client supports v%d\n",zm2,PROTOCOL);
sprintf(statr+strlength(statr),"Please get the newest version of NetWoorms on %s\n",MYURL);
ie(-1,statr);
}
while (recv(sw[1],&zm2,1,0)<1);
myn[1]=zm2;
fout=0;
while (!fout)
{
recv(sw[1],&zm2,1,0);
if (zm2==0) fout=1;
}
memset(stata,32,RX-1);
memset(statt,32,RX-1);
memset(statc,48,RX-1);
memset(stats,48,RX-1);
*(stata+RX-1)=0;
*(statt+RX-1)=0;
*(statc+RX-1)=0;
*(stats+RX-1)=0;
*stati=0;
*statr=0;
siga.sa_handler=handlerf;
sigaction(SIGALRM,&siga,NULL);

curs_init();

SPEED=(SPEED*REFRMOD);
init_timr();
SPEED=(SPEED/REFRMOD);

sprintf(statr,"[\n0NetWoorms\n1 client v%s]",VERSION);
stat_put(statr);
gout=0;

while (!gout)
{
kp=getch();
switch(kp)
{
case 27:
{
kp=getch();
if (kp=91)
{
zm3=0;
kp=getch();
switch(kp)
{
case 65: key_press(1,1); break;
case 67: key_press(2,1); break;
case 66: key_press(3,1); break;
case 68: key_press(4,1); break;
case 91:
{
kp=getch();
switch(kp)
{
case 65: zm3=1; break;
case 66: zm3=2; break;
case 67: zm3=3; break;
case 68: zm3=4; break;
case 69: zm3=5; break;
}
break;
}
case '1':
{
kp=getch();
switch(kp)
{
case '7': zm3=6; break;
case '8': zm3=7; break;
case '9': zm3=8; break;
}
break;
}
case '2':
{
kp=getch();
switch(kp)
{
case '0': zm3=9; break;
case '1': zm3=10; break;
case '3': zm3=11; break;
case '4': zm3=12; break;
}
break;
}
}
if (zm3>0)
{
zm2=0;
if (zm3<7 || sw[2]==0)
{
wt=tks[0][zm3];
if (wt!=NULL)
{
send(sw[1],&zm2,1,0);
send(sw[1],wt,strlength(wt)+1,0);
}
}
else
{
wt=tks[1][zm3-6];
if (wt!=NULL)
{
send(sw[2],&zm2,1,0);
send(sw[2],wt,strlength(wt)+1,0);
}
}
}
}

if (kp==ERR) gout=1;
break;
}

case 9:
{
if (sw[2]==0)
{
sw[2]=conn_open(HOST,PORT);
send(sw[2],nme[2],strlength(nme[2])+1,0);
myn[2]=0;

while (recv(sw[2],&zm2,1,0)<1);
while (recv(sw[2],&zm2,1,0)<1);
myn[2]=zm2;
fout=0;
while (!fout)
{
recv(sw[2],&zm2,1,0);
if (zm2==0) fout=1;
}
}
else
{
close(sw[2]);
sw[2]=0;
}
break;
}
case 10: if (sw[2]==0) {
zm2=0;
send(sw[1],&zm2,1,0);
send(sw[1],stati,strlength(stati)+1,0);
*stati=0;
}; break;

case '8': if (sw[2]!=0) {key_press(1,1); break;}
case '6': if (sw[2]!=0) {key_press(2,1); break;}
case '5': if (sw[2]!=0) {key_press(3,1); break;}
case '2': if (sw[2]!=0) {key_press(3,1); break;}
case '4': if (sw[2]!=0) {key_press(4,1); break;}

case 'W':
case 'w': if (sw[2]!=0) {key_press(1,2); break;}
case 'E':
case 'e': if (sw[2]!=0) {key_press(1,2); break;}
case 'A':
case 'a': if (sw[2]!=0) {key_press(4,2); break;}
case 'S':
case 's': if (sw[2]!=0) {key_press(3,2); break;}
case 'D':
case 'd': if (sw[2]!=0) {key_press(2,2); break;}
case 'Z':
case 'z': if (sw[2]!=0) {key_press(3,2); break;}
case 'X':
case 'x': if (sw[2]!=0) {key_press(3,2); break;}
default:
{
if (kp>=32 && kp<=126)
{
zm=strlength(stati);
if (zm<(RX-1) && sw[2]==0)
{
*(stati+zm)=kp;
*(stati+zm+1)=0;
}
}
}
}

while (recv(sw[1],&kc,1,0)>0)
{
if (kc==1)
{
zm=0;
do {
while (!(recv(sw[1],pckt+zm,1,0)+1));
zm++;
} while (zm<4);
area_put(*(pckt),*(pckt+1),*(pckt+2),*(pckt+3));
}
if (kc==0)
{
zm=0;
do {
while (!(recv(sw[1],&kr,1,0)+1));
if (zm<(RX-1))
{
*(statr+zm)=kr;
zm++;
}
} while ((kr>0));
*(statr+zm)=0;
stat_put(statr);
}
if (kc==2)
{
relk[1]=0;
}
}

if (sw[2]>0)
{

while (recv(sw[2],&kc,1,0)>0)
{
if (kc==1)
{
zm=0;
do {
while (!(recv(sw[2],pckt,1,0)+1));
zm++;
} while (zm<4);
}
if (kc==0)
{
do {
while (!(recv(sw[2],&kr,1,0)+1));
} while (kr>0);
}
if (kc==2)
{
relk[2]=0;
}
}

}
doupdate();
pause();
};
endwin();
};
