#include "config.h"
#include <getopt.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "anw.h"

#define RX 180

void
usage()
{
	fprintf(stderr,PACKAGE " " VERSION " by pawel@sakowski.eu.org\n"
	"Usage:\t" PACKAGE " [options] [worm_name]\n\nOptions:\n"
	"-h/--help                   This help\n"
	"-s/--server server[:port]   The nwoosrv to connect to\n"
	);
	exit(0);
}

static struct option long_options[] = {
{"help",0,0,'h'},
{"server",1,0,'s'},
{0,0,0,0}};

void
incoming()
{
	unsigned char type;
	char *mess;
	int messlen;
	struct screen pix;
	while (!receive(&type,1,0)) switch (type) {
	case PACK_MESS:
		mess=NULL;
		for(messlen=1;;messlen++) {
			if (messlen>RX+1) {
				errno=EMSGSIZE;
				gr_error("PACK_MESS");
			}
			if (messlen%10==1) {
				mess=(char *)realloc(mess,messlen+9);
				if (!mess) gr_error("realloc");
			}
			receive(mess+messlen-1,1,1);
			if (!mess[messlen-1]) break;
		}
		gr_addstatus(mess);
//		free(mess);
		break;
	case PACK_SCREEN:
		receive(&pix,sizeof(pix),1);
		gr_pixel(&pix);
		int_pixel(&pix);
		break;
	case PACK_DEATH:
		int_die();
		break;
	default:
		errno=EBADRQC;
		gr_error("protocol");
	}
	gr_scroll();
	gr_sync();
}

void
outgoing()
{
	int ch,move;
	move=sugmove;
	while (ch=gr_getch()) switch (ch) {
	case Kup:case Kright:case Kdown:case Kleft:
		if (ch!=lastmove || !int_noblock) move=ch;
	}
	if (move!=Kerr) {transmit(&move,1);lastmove=move;}
	sugmove=Kerr;
}

int
main(int ac,char **av)
{
	int ch;
	char *ptr;
	while ((ch=getopt_long(ac,av,"hs:",long_options,0))!=EOF) switch (ch) {
	case 'h': usage();
	case 's':
		if (ptr=strchr(optarg,':')) {
			*(ptr++)=0;
			remoteport=atoi(ptr);
		}
		remotehost=strdup(optarg);
		break;
	default:
		return 1;
	}
	if (optind<ac) myname=av[optind++];
	if (optind<ac) {
		fprintf(stderr, "anw: Too many arguments\n");
		return 1;
	}
	contact();
	gr_init();
	int_init();
	for(;;) {
		holdit();
		incoming();
		outgoing();
	}
	gr_close();
	return 0;
}
